import { EventEmitter, DefaultEventMap } from "tsee";
import { CrashDetectFunctions } from "./functions";
export * from "./functions";
export * from "./extension";
export * from "./context-events";
export interface CrashDetectEventMap extends DefaultEventMap {
    "runtime-error": (crash: CrashDetect, code: number) => any;
}
export declare class CrashDetect extends CrashDetectFunctions {
    static readonly events: EventEmitter<CrashDetectEventMap>;
    static readonly on: <EventKey extends keyof CrashDetectEventMap = string>(event: EventKey, listener: CrashDetectEventMap[EventKey]) => EventEmitter<CrashDetectEventMap>;
    static init(): void;
    static emit<EventKey extends keyof CrashDetectEventMap>(key: EventKey, crash: CrashDetect, ...args: Parameters<CrashDetectEventMap[EventKey]>): number | void;
    retval?: number;
}
