"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrashDetect = void 0;
const amx = require("@sa-mp/amx");
const tsee_1 = require("tsee");
const functions_1 = require("./functions");
__exportStar(require("./functions"), exports);
__exportStar(require("./extension"), exports);
__exportStar(require("./context-events"), exports);
class CrashDetect extends functions_1.CrashDetectFunctions {
    static init() {
        amx.onPublicCall("OnRuntimeError", "i", (code) => {
            const crash = new CrashDetect;
            return CrashDetect.emit("runtime-error", crash, crash, code);
        });
    }
    static emit(key, crash, ...args) {
        CrashDetect.events.emit(key, ...args);
        const { retval } = crash;
        if (typeof retval === "number")
            return retval;
    }
}
exports.CrashDetect = CrashDetect;
CrashDetect.events = new tsee_1.EventEmitter;
CrashDetect.on = CrashDetect.events.on;
CrashDetect.init();
